diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteKeyEvent.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteKeyEvent.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteKeyEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteKeyEvent.java	2017-01-29 02:51:16.645856000 +0900
@@ -0,0 +1,34 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteKeyEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+
+	private final int action;
+	private final int code;
+	private final int source;
+	
+	public RemoteKeyEvent(int action, int code, int source)
+	{
+		this.action = action;
+		this.code = code;
+		this.source = source;
+	}
+	
+	public int getAction()
+	{
+		return action;
+	}
+	
+	public int getCode()
+	{
+		return code;
+	}
+	
+	public int getSource()
+	{
+		return source;
+	}
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteLocation.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteLocation.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteLocation.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteLocation.java	2017-01-29 02:51:16.649856000 +0900
@@ -0,0 +1,93 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+import android.location.Location;
+import android.os.Bundle;
+
+public class RemoteLocation implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private final String mProvider;
+    private final long mTime;
+    private final long mElapsedRealtimeNanos;
+    private final double mLatitude;
+    private final double mLongitude;
+    private final double mAltitude;
+    private final float mSpeed;
+    private final float mBearing;
+    private final float mAccuracy;
+    private final Bundle mExtras;
+    private final boolean mIsFromMockProvider;
+    
+    public RemoteLocation(Location l)
+    {
+    	mProvider = l.getProvider();
+        mTime = l.getTime();
+        mElapsedRealtimeNanos = l.getElapsedRealtimeNanos();
+        mLatitude = l.getLatitude();
+        mLongitude = l.getLongitude();
+        mAltitude = l.getAltitude();
+        mSpeed = l.getSpeed();
+        mBearing = l.getBearing();
+        mAccuracy = l.getAccuracy();
+        mExtras = (l.getExtras() == null) ? null : new Bundle(l.getExtras());
+        mIsFromMockProvider = l.isFromMockProvider();
+    }
+    
+    public String getProvider()
+    {
+    	return mProvider;
+    }
+
+	public long getTime()
+	{
+		return mTime;
+	}
+
+	public long getElapsedRealtimeNanos()
+	{
+		return mElapsedRealtimeNanos;
+	}
+
+	public double getLatitude()
+	{
+		return mLatitude;
+	}
+
+	public double getLongitude()
+	{
+		return mLongitude;
+	}
+
+	public double getAltitude()
+	{
+		return mAltitude;
+	}
+
+	public float getSpeed()
+	{
+		return mSpeed;
+	}
+
+	public float getBearing()
+	{
+		return mBearing;
+	}
+
+	public float getAccuracy()
+	{
+		return mAccuracy;
+	}
+
+	public Bundle getExtras()
+	{
+		return mExtras;
+	}
+
+	public boolean isFromMockProvider()
+	{
+		return mIsFromMockProvider;
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteMotionEvent.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteMotionEvent.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteMotionEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteMotionEvent.java	2017-01-29 02:51:16.637856000 +0900
@@ -0,0 +1,60 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteMotionEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private final long downTime;
+	private final long eventTime;
+	private final float x;
+	private final float y;
+	private final int action;
+	private final int source;
+	
+	public RemoteMotionEvent(long downTime, long eventTime, float x, float y, int action, int source)
+	{
+		this.downTime = downTime;
+		this.eventTime = eventTime;
+		this.x = x;
+		this.y = y;
+		this.action = action;
+		this.source = source;
+	}
+	
+	public long getDownTime()
+	{
+		return downTime;
+	}
+	
+	public long getEventTime()
+	{
+		return eventTime;
+	}
+	
+	public float getX()
+	{
+		return x;
+	}
+	
+	public float getY()
+	{
+		return y;
+	}
+	
+	public int getAction()
+	{
+		return action;
+	}
+	
+	public int getSource()
+	{
+		return source;
+	}
+	
+	public String toString()
+	{
+		return "(" + x + ", " + y + ")";
+	}
+}
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteSensorEvent.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteSensorEvent.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/RemoteSensorEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/RemoteSensorEvent.java	2017-01-29 02:51:16.637856000 +0900
@@ -0,0 +1,53 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteSensorEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private int type;
+	private int sensor;
+	private float values[];
+	private int accuracy;
+	private long timestamp;
+	
+	public RemoteSensorEvent(int type, int sensor, float[] values, int accuracy, long timestamp)
+	{
+		this.type = type;
+		this.sensor = sensor;
+		this.values = values;
+		this.accuracy = accuracy;
+		this.timestamp = timestamp;
+	}
+	
+	public int getType()
+	{
+		return type;
+	}
+	
+	public int getSensor()
+	{
+		return sensor;
+	}
+	
+	public float[] getValues()
+	{
+		return values;
+	}
+	
+	public int getAccuracy()
+	{
+		return accuracy;
+	}
+	
+	public long getTimestamp()
+	{
+		return timestamp;
+	}
+	
+	public String toString()
+	{
+		return "(" + type + ": " + values[0] + ", " + values[1] + ")";
+	}
+}
\ No newline at end of file
